#! /bin/sh

set -e

LOG_FILENAME='/var/log/xivo-dird.log'
DIRD_ALEMBIC_INI_PATH='/usr/share/xivo-dird'


is_postgres_9_running() {
    if pg_lsclusters --no-header | grep -q online ; then
        return 0
    else
        return 1
    fi
}

is_postgres_11_running_on_port() {
    result=$(psql -h localhost -p $1 -U postgres --quiet -tAc "SELECT 1 FROM pg_catalog.pg_database WHERE datname='$2'" 2> /dev/null)

    [ $? -eq 0 ] && [ "$result" = "1" ]
}

init_or_upgrade_dird_db() {
    xivo-dird-init-db --user postgres
    echo "Upgrading xivo-dird database ..."
    (cd $DIRD_ALEMBIC_INI_PATH && python3 -m alembic.config -c alembic.ini upgrade head)
}

case "$1" in
    configure)
        previous_version="$2"
        if [ -z "$previous_version" ]; then
            if is_postgres_11_running_on_port 5432 asterisk; then
                init_or_upgrade_dird_db
            fi
        else
            if dpkg --compare-versions "$previous_version" "<<" "2019.04.00"; then
                if is_postgres_9_running; then
                    init_or_upgrade_dird_db
                fi
            elif is_postgres_11_running_on_port 5432 asterisk; then
                init_or_upgrade_dird_db
            fi
        fi

        if [ ! -e "$LOG_FILENAME" ]; then
            touch "$LOG_FILENAME"
        fi
        chown www-data: "$LOG_FILENAME"

        # source_to_display_columns migration
        files=$(grep -rIn 'source_to_display' /etc/xivo-dird/sources.d/* | awk -F ':' '{print $1}')
        for file in $files; do
            /usr/share/xivo-dird/migrations/0001_source_to_display_columns_to_format_columns.py $file
        done
    ;;

    abort-upgrade|abort-remove|abort-deconfigure)
    ;;

    *)
        echo "postinst called with unknown argument \`$1'" >&2
        exit 1
    ;;
esac

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.

#DEBHELPER#

exit 0
